<?php
/*
Copyright  2005 Alberto Martnez Fernndez (albertinho_2000@hotmail.com)
				 Israel Ortiz Flores (i_ortiz_flores@hotmail.com)
 
Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Sections, no Front-Cover Texts, and no Back-Cover Texts. A
copy of the license can be found in http://www.gnu.org/licenses/fdl.txt 
*/
	
	//Hacemos un array con todos los ficheros que hay que compilar
	$path=realpath("../users/$user/$name");	
	$handler=opendir($path);
	$compile_files = array();
	$j=0;
	$long_extension=strlen($extensions[$languaje][0]);
	while ($file_act=readdir($handler)) {
		$extension_file=strtolower(substr($file_act, strlen($file_act)-$long_extension, $long_extension));
		if  ($extension_file==$extensions[$languaje][0]){
			$compile_files[$j]=$file_act;
			$j++;
		}
	}
	closedir($handler);
	
	$retval=0;
	//Comprobamos si hay ficheros para construir
	if (count($compile_files)==0) {
		$mensaje="You haven't got ". $languaje." files.";

		//Escribimos el resultado de que no tiene ficheros del tipo del proyecto 
		$fd=fopen($result_file,"w");
		fwrite($fd, $mensaje);
		fclose($fd);
		//Hay errores, no debemos seguir
		$retval=1;
	}
	
	//Compilamos los ficheros antes de generar el ejecutable
	for ($i=0; $retval==0 && $i<count($compile_files); $i++) {
		$compile_file = realpath("$path/$compile_files[$i]");
		//$old_cwd=getcwd();
		//chdir(dirname($path_compiler));
		//$command=basename($path_compiler).' -c "'.$compile_file.'" -o "'.$compile_file.'.o" 2> "'.$result_file.'"';
		$command=$path_compiler.' -c "'.$compile_file.'" -o "'.$compile_file.'.o" 2>> "'.$result_file.'"';
		system($command, $retval);
		//chdir($old_cwd);
	
		/*
		//Si algun fichero tiene error, paramos la compilacion
		if ($retval==1) {
			break;
		}
		*/
	}
		
	//No hay errores en la compilacion, construimos el ejecutable
	if ($retval==0) {
		//Nos quedamos con los ficheros objeto
		$path=realpath("../users/$user/$name");	
		$handler=opendir($path);
		$object_files="";
		while ($file_act=readdir($handler)) {
			if  (strtolower(substr($file_act, strlen($file_act)-1, 1))=="o") {
				$object_files.='"'.realpath("$path/$file_act").'" ';
			}
		}
		closedir($handler);
		
		//Construimos el ejecutable
		$exec_file=realpath("../users/$user/$name")."/".substr($name, 0, 7).".exe";
		//$exec_file=realpath("../users/$user/$name")."/".substr($name, 0, 7);

		//$old_cwd=getcwd();
		//chdir(dirname($path_compiler));
		//$command=basename($path_compiler).' -o "'.$exec_file.'" '.$object_files.' -mconsole 2> "'.$result_file.'"';
		$command=$path_compiler.' -o "'.$exec_file.'" '.$object_files.' -mconsole 2>> "'.$result_file.'"';
		system($command, $retval);
		//chdir($old_cwd);
		
		//Indicamos en el fichero resultado que todo ha ido bien
		$fd=fopen ($result_file,"a");
		if ($retval==0) {
			fwrite($fd,"Build successfully.");
		}
		else {
			fwrite($fd,"There are errors with building.");
		}	
		fclose($fd);
	}

	//Borramos los ficheros de codigo objeto
	$path=realpath("../users/$user/$name");
	$handler=opendir($path);
	while($file=readdir($handler)) {
		if  (strtolower(substr($file, strlen($file)-1, 1))=="o") {
			$pathfile=realpath("$path/$file");
			unlink($pathfile);
		}
	}
	closedir($handler);

	if ($retval!=0) {	
		//Quitamos los textos que son basura del fichero
		//Abrimos el fichero resultado
		$fd=fopen ($result_file,"r");
		$result = fread($fd, filesize($result_file));
		fclose($fd);
		//$pattern=addslashes($compile_file);
		$path="../users/$user/$name/";
		$pattern=addslashes(realpath($path));
		$result = str_replace($pattern.'/', "", $result);
		$result = str_replace($pattern.'\\\\', "", $result);
		//Guardamos el fichero
		$fd=fopen ($result_file,"w");
		fwrite($fd, $result);
		fclose($fd);
	}
?>
